# This file is a template, and might need editing before it works on your project.
# Build JAVA applications using Apache Maven (http://maven.apache.org)
# For docker image tags see https://hub.docker.com/_/maven/
#
# For general lifecycle information see https://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html

# This template will build and test your projects
# * Caches downloaded dependencies and plugins between invocation.
# * Verify but don't deploy merge requests.
# * Deploy built artifacts from master branch only.

variables:
  # This will suppress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  #MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true -Dmaven.wagon.http.ssl.insecure=true -Dmaven.wagon.http.ssl.allowall=true -Dmaven.wagon.http.ssl.ignore.validity.dates=true"  
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
  #MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true --settings .m2/settings.xml"
  MAVEN_CLI_OPTS: "--batch-mode --errors --show-version --settings $CI_PROJECT_DIR/.m2/settings.xml"  

# This template uses jdk8 for verifying and deploying images
#image: maven:3.3.9-jdk-8
image: maven:3.6.3-jdk-8
#image: maven:latest

# Cache downloaded dependencies and plugins between builds.
# To keep cache across branches add 'key: "$CI_JOB_NAME"'
cache:
  paths:
    - .m2/repository

# For merge requests do not `deploy` but only run `verify`.
# See https://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html
.verify: &verify
  stage: test
  script:
    - echo $ARTIFACTORY_PASSWORD
    - echo $ARTIFACTORY_USERNAME
    - mvn $MAVEN_CLI_OPTS test
    - mvn $MAVEN_CLI_OPTS verify
    - pwd
  except:
    - master
    - dev

# Verify merge requests using JDK8
#verify:jdk8:
#  <<: *verify

#mvn_package:jdk8:
#  stage: build
#  script:
#    - echo  MAVEN_CLI_OPTS=$MAVEN_CLI_OPTS
#    - mvn $MAVEN_CLI_OPTS package
#  except: 
#    - dev

# For `dev` branch run `mvn vrealize:push` automatically.
deploy-dev:jdk8:
  stage: deploy
  script:
    - pwd
    - echo $MAVEN_REPO_URL    
    - echo $ARTIFACTORY_PASSWORD
    - echo $ARTIFACTORY_USERNAME
    - echo $MAVEN_CLI_OPTS
    - echo $MAVEN_OPTS
    - echo MAVEN_CLI_OPTS=$MAVEN_CLI_OPTS
    - mvn clean
    - mvn $MAVEN_CLI_OPTS -DskipTests=true --projects actions,workflows deploy
    - mvn $MAVEN_CLI_OPTS -DskipTests=true package vrealize:push -Pvra8ng
  except:
    - dev

# # For `dev` branch run `mvn vrealize:push` automatically.
release-dev:jdk8:
   stage: deploy
   script:
     - pwd
     - echo $MAVEN_REPO_URL    
     - echo $ARTIFACTORY_PASSWORD
     - echo $ARTIFACTORY_USERNAME
     - echo $MAVEN_CLI_OPTS
     - echo $MAVEN_OPTS
     - echo MAVEN_CLI_OPTS=$MAVEN_CLI_OPTS
     - echo ${CI_BUILD_REF_NAME}
     - mkdir ~/.ssh
     - cp ${GITLAB_SSH_KEY} ~/.ssh/id_rsa
     - cp ${SSH_PUBLIC_KEY} ~/.ssh/id_rsa.pub
     - cp ${GITLAB_SSH_KEY} ~/.ssh/known_hosts 
     - ssh-keyscan -p 22 -H gitlab.lab.lostroncos.net >> ~/.ssh/known_hosts
     - ssh-keyscan -p 22 -H 10.0.0.41 >> ~/.ssh/known_hosts     
     - chmod 700 ~/.ssh/id_rsa
     - git config --global user.email "cars@lab.lostroncos.net"
     - git config --global user.name "cars"     
     - git checkout -B ${CI_BUILD_REF_NAME}
     - mvn $MAVEN_CLI_OPTS -DskipTests=true release:clean
     - mvn $MAVEN_CLI_OPTS -DskipTests=true release:prepare
     - mvn $MAVEN_CLI_OPTS -DskipTests=true release:perform 
     - mvn package vrealize:push -DcleanupLastVersion=false -DcleanupOldVersions=true -DincludeDependencies=trye -Pvra8ng

   only:
     - dev    

#     # For `master` branch run `mvn deploy` automatically.
# deploy:jdk8:
#   stage: deploy
#   script:
#     - if [ ! -f ci_settings.xml ];
#         then echo "CI settings missing\! If deploying to GitLab Maven Repository, please see https://docs.gitlab.com/ee/user/project/packages/maven_repository.html#creating-maven-packages-with-gitlab-cicd for instructions.";
#       fi
#     - 'mvn $MAVEN_CLI_OPTS deploy -s ci_settings.xml'
#   only:
#     - main    
